class Klient {
  private BankovniUcet ucet;
  private int osobniCislo;

  Klient(int vklad, int cislo) {
    ucet = new BankovniUcet(vklad);
    osobniCislo = cislo;
  }

  public int getOsobniCislo() { return osobniCislo; }

  public int getHotovost() { return ucet.getHotovost(); }

  public void vloz(int vklad) { ucet.vloz(vklad); }

  public int vyber(int suma) { return ucet.vyber(suma); }

  public void vypisUctu() {
    System.out.print("Klient: " + osobniCislo + ", ");
    ucet.vypisUctu();
  }
}

class BankovniUcet {
  private int hotovost;

  BankovniUcet(int vklad) {
    hotovost = vklad;
  }

  BankovniUcet() {
    this(0);
  }

  public int getHotovost() { return hotovost; }

  public void vloz(int vklad) { hotovost += vklad; }

  public int vyber(int suma) {
    if (hotovost >= suma) {
      hotovost -= suma;
      return suma;
    }
    else {
      int zbytek = suma - hotovost;
      hotovost = 0;
      return zbytek;
    }
  }

  public void vypisUctu() {
    System.out.println("Hotovost: " + hotovost);
  }

}

public class Banka {
  static final int N = 10;
  public static void main(String[] args) {
    Klient[] klienti = new Klient[N];
    for (int i = 0;  i < klienti.length;  i++) {
      klienti[i] = new Klient((int) (Math.random() * 1000), i);
    }

    klienti[0].vloz(2000);
    klienti[0].vypisUctu();
    klienti[0].vyber(1000);
    klienti[0].vypisUctu();
    klienti[0].vyber(5000);
    klienti[0].vypisUctu();

    int hotovostVBance = 0;
    for (int i = 0;  i < klienti.length;  i++) {
      hotovostVBance += klienti[i].getHotovost();
    }

    System.out.println("Celkova hotovost: " + hotovostVBance);
  }
}
