class Kolo {
  private String vyrobce;
  private int cena;
  private boolean maPrehazovacku;

  Kolo(String vyrobce, int cena, boolean maPrehazovacku) {
    this.vyrobce = vyrobce;
    this.cena = cena;
    this.maPrehazovacku = maPrehazovacku;
  }

  public String getVyrobce() { return vyrobce; }

  public int getCena() { return cena; }

  public boolean getPrehazovacka() { return maPrehazovacku; }

  public void setCena(int novaCena) { cena = novaCena; }

  public void setPrehazovacka(boolean prehazovacka) {
    maPrehazovacku = prehazovacka;
  }

  public String toString() {
    return ("Vyrobce/znacka: " + vyrobce +
                        ", cena: " + cena +
                        ", prehazovacka: " + maPrehazovacku);
  }

}

class HorskeKolo extends Kolo {
  private int prevodyVpredu;
  private int prevodyVzadu;

  HorskeKolo(String vyrobce, int cena, int prevodyVpredu, int prevodyVzadu) {
    super(vyrobce, cena, true);
    this.prevodyVpredu = prevodyVpredu;
    this.prevodyVzadu = prevodyVzadu;
  }

  public int getPocetRychlosti() { return prevodyVpredu * prevodyVzadu; }

  public void setPrevodyVzadu(int pocet) { prevodyVzadu = pocet; }

  public String toString() {
    String kolo = super.toString();
    // vymazani informace o prehazovacce
    String pom = kolo.substring(0, kolo.indexOf(", prehazovacka: "));

    pom = pom.concat(", pocet rychlosti (vcetne krizeni retezu ;-): ");
    pom = pom.concat(String.valueOf(this.getPocetRychlosti()));
    return pom;
  }

}


public class TestKol {
  public static void main(String[] args) {
    Kolo fav = new Kolo("favorit", 2000, true);
    Kolo ukr = new Kolo("ukraina", 800, false);

    System.out.println("Bezna kola:");
    System.out.println(fav.toString());
    System.out.println(ukr.toString());
    System.out.println("Cena po vylepseni:");
    ukr.setPrehazovacka(true);
    ukr.setCena(1500);
    System.out.println(ukr.toString());

    System.out.println("\nHorska kola:");
    HorskeKolo aut = new HorskeKolo("Author", 19990, 3, 9);
    HorskeKolo fox = new HorskeKolo("Leader Fox", 15000, 3, 7);
    System.out.println(aut.toString());
    System.out.println(fox.toString());
    System.out.println("Cena po vylepseni:");
    fox.setPrevodyVzadu(8);
    fox.setCena(17000);
    System.out.println(fox.toString());

  }
}
