// univerzalni spojovy seznam

class EmptyListException extends RuntimeException {
  public EmptyListException() {
    System.out.println("Seznam je prazdny nebo prvek neni v seznamu");
  }
}

class Uzel {
  Object prvek;
  Uzel dalsi;

  Uzel(Object o) {
    prvek = o;
    dalsi = null;
  }

  Uzel(Object o, Uzel dalsiUzel) {
    prvek = o;
    dalsi = dalsiUzel;
  }

  Object getPrvek() { return prvek; }

  Uzel getDalsi() { return dalsi; }
}

class SpojovySeznam {
  private Uzel prvni, posledni;
  int pocet;

  SpojovySeznam() { prvni = posledni = null;  pocet = 0; }

  public boolean jePrazdny() {
    return (prvni == null) ? true : false;
  }

  // vklada na konec
  public void vloz(Object vkladany) {
    if (jePrazdny() == true)
      prvni = posledni = new Uzel(vkladany);
    else
      posledni = posledni.dalsi = new Uzel(vkladany);

    pocet++;
  }

  public void vypisSeznam() {
    Uzel akt = prvni;
    while (akt != null) {
      System.out.println(akt.prvek.toString());
      akt = akt.dalsi;
    }
    System.out.println("Pocet prvku: " + pocet);
  }

  public Object vyjmiPrvniho() throws EmptyListException {
    Object o;
    if (jePrazdny() == true)
      throw new EmptyListException();

    pocet--;
    o = prvni.prvek;
    if (prvni != posledni)
      prvni = prvni.dalsi;
    else
      prvni = posledni = null;

    return o;
  }

  public int getPocet() { return pocet; }
}

public class SpojovySeznamTest {
  public static void main(String[] args) {
    SpojovySeznam s = new SpojovySeznam();
    Integer i = new Integer(1);
    Double d = new Double(3.14);
    String a = "ahoj";
    s.vloz(i);
    s.vloz(d);
    s.vloz(a);
    s.vypisSeznam();
    s.vyjmiPrvniho();
    s.vypisSeznam();
    s.vyjmiPrvniho();
    s.vypisSeznam();
    s.vyjmiPrvniho();
    s.vypisSeznam();
    s.vyjmiPrvniho();
    s.vypisSeznam();
  }
}
