// univerzalni spojovy seznam

import java.io.*;

class EmptyListException extends RuntimeException {
  public EmptyListException() {
    System.out.println("Seznam je prazdny nebo prvek neni v seznamu");
  }
}

class Uzel {
  Object prvek;
  Uzel dalsi;

  Uzel(Object o) {
    prvek = o;
    dalsi = null;
  }

  Uzel(Object o, Uzel dalsiUzel) {
    prvek = o;
    dalsi = dalsiUzel;
  }

  Object getPrvek() { return prvek; }

  Uzel getDalsi() { return dalsi; }
}

class SpojovySeznam {
  private Uzel prvni, posledni;
  int pocet;

  SpojovySeznam() { prvni = posledni = null;  pocet = 0; }

  public boolean jePrazdny() {
    return (prvni == null) ? true : false;
  }

  public int getPocet() { return pocet; }

  // vklada na konec
  public void vloz(Object vkladany) {
    if (jePrazdny() == true)
      prvni = posledni = new Uzel(vkladany);
    else
      posledni = posledni.dalsi = new Uzel(vkladany);

    pocet++;
  }

  public void vypisSeznam() {
    Uzel akt = prvni;
    while (akt != null) {
      System.out.println(akt.prvek.toString());
      akt = akt.dalsi;
    }
    System.out.println("Pocet prvku: " + pocet);
  }

  public Object vyjmiPrvniho() throws EmptyListException {
    Object o;
    if (jePrazdny() == true)
      throw new EmptyListException();

    pocet--;
    o = prvni.prvek;
    if (prvni != posledni)
      prvni = prvni.dalsi;
    else
      prvni = posledni = null;

    return o;
  }

  public void odstranit(Object o) throws EmptyListException {
    Uzel pred, za;

    pred = za = prvni;
    while (za.prvek != o  &&  za != null) {
      pred = za;
      za = za.dalsi;
    }

    if (za != null)
      odstranit(za);
  }

  public void odstranit(Uzel vypousteny) throws EmptyListException {
    Uzel pred, za;
    if (jePrazdny() == true)
      throw new EmptyListException();

    if (prvni == vypousteny) {
      if (posledni == vypousteny)
        prvni = posledni = null;
      else
        prvni = prvni.dalsi;
      vypousteny = null;
      pocet--;
      return;
    }

    pred = za = prvni;
    while (za != vypousteny  &&  za != null) {
      pred = za;
      za = za.dalsi;
    }

    if (za == null)
      throw new EmptyListException();

    pred.dalsi = za.dalsi;
    vypousteny = null;
    pocet--;

    if (za == posledni)
      posledni = pred;
  }
}

class SouborVSeznamu {
  FileReader fr;
  BufferedReader bfr;
  SpojovySeznam s;
  String[] pole;
  int pocet;

  SouborVSeznamu(String jmeno) {
    try {
      s = new SpojovySeznam();
      fr = new FileReader(jmeno);
      bfr = new BufferedReader(fr);
      String radka;
      while ((radka = bfr.readLine()) != null) {
        s.vloz(radka);
      }
      bfr.close();
    }
    catch (IOException e) {
      e.printStackTrace();
    }
    pocet = s.getPocet();
    pole = new String[pocet];
    for (int i = 0;  i < pocet;  i++) {
      pole[i] = (String) s.vyjmiPrvniho();
    }
    s = null;
  }

  public int getPocet() { return pocet; }

  public String getRadku(int i) { return pole[i]; }
}

public class SpojovySeznamTest {
  public static void main(String[] args) throws EmptyListException {
    SouborVSeznamu f = new SouborVSeznamu("a.txt");
    int pocet = f.getPocet();
    for (int i = 0;  i < pocet;  i++) {
      System.out.println(f.getRadku(i));
    }
  }
}

