import java.io.*;
import java.util.*;

class FiltrMasky implements FilenameFilter {
  String jmeno, pripona;
  boolean hvezdaJmeno, hvezdaPripona;

  FiltrMasky(String maska) {
    int i = maska.indexOf('.');
    if (maska.charAt(i - 1) == '*') {
      hvezdaJmeno = true;
      jmeno = new String(maska.substring(0, i - 1));
    }
    else {
      hvezdaJmeno = false;
      jmeno = new String(maska.substring(0, i));
    }

    if (maska.endsWith("*") == true) {
      hvezdaPripona = true;
      pripona = new String(maska.substring(i + 1, maska.length() - 1));
    }
    else {
      hvezdaPripona = false;
      pripona = new String(maska.substring(i + 1));
    }
  }

  private boolean vyhovuje(String orig, String maska, boolean hvezda) {
    if (hvezda == true) {
      // staci, kdyz se rovnaji zacatky
      if (orig.startsWith(maska) == true) {
        return true;
      }
      else {
        return false;
      }
    }
    else {
      // musi se rovnat cele
      if (orig.compareToIgnoreCase(maska) == 0) {
        return true;
      }
      else {
        return false;
      }
    }
  }

  public boolean accept(File dir, String name) {
    File f = new File(dir, name);
    if (f.isFile() == false)
      return false;

    int i = name.indexOf('.');
    if (i == -1)
      return false;   // nedotazene, soubor nemusi mit priponu

    String jm = new String(name.substring(0, i));
    String pr = new String(name.substring(i + 1));

    if (vyhovuje(jm, jmeno, hvezdaJmeno)
        &&  vyhovuje(pr, pripona, hvezdaPripona)) {
      return true;
    }
    else {
      return false;
    }
  }
}


public class SouboryVAdresari {
  static int pocetVsech = 0;

  public static void main(String[] args) {
    Scanner sc = new Scanner(System.in);
    String jmenoAktDir, maska;

    if (args.length == 0) {
      jmenoAktDir = System.getProperty("user.dir");
      maska = "*.*";
    }
    else {
      jmenoAktDir = new String(args[0]);
      System.out.print("Zadej masku souboru (napr. a*.ja* ): ");
      maska = sc.nextLine();
    }

    System.out.println("Vypisuji soubory: " + jmenoAktDir + "\\" + maska);

    File aktDir = new File(jmenoAktDir);
    String[] jmena;
    FiltrMasky filtrMas = new FiltrMasky(maska);
    jmena = aktDir.list(filtrMas);
    pocetVsech = jmena.length;
    for (int i = 0;  i < jmena.length;  i++)
      System.out.println(jmena[i]);

    System.out.println("Celkovy pocet vsech souboru: " + pocetVsech);
  }
}
