import java.io.*;
import java.util.*;

class FiltrAdresaru implements FilenameFilter {
  FiltrAdresaru() {
  }

  public boolean accept(File dir, String name) {
    File f = new File(dir, name);
    return f.isDirectory();
  }
}

class FiltrMasky implements FilenameFilter {
  String jmeno, pripona;
  boolean hvezdaJmeno, hvezdaPripona;

  FiltrMasky(String maska) {
    int i = maska.indexOf('.');
    if (maska.charAt(i - 1) == '*') {
      hvezdaJmeno = true;
      jmeno = new String(maska.substring(0, i - 1));
    }
    else {
      hvezdaJmeno = false;
      jmeno = new String(maska.substring(0, i));
    }

    if (maska.endsWith("*") == true) {
      hvezdaPripona = true;
      pripona = new String(maska.substring(i + 1, maska.length() - 1));
    }
    else {
      hvezdaPripona = false;
      pripona = new String(maska.substring(i + 1));
    }
  }

  private boolean vyhovuje(String orig, String maska, boolean hvezda) {
    if (hvezda == true) {
      // staci, kdyz se rovnaji zacatky
      if (orig.startsWith(maska) == true) {
        return true;
      }
      else {
        return false;
      }
    }
    else {
      // musi se rovnat cele
      if (orig.compareToIgnoreCase(maska) == 0) {
        return true;
      }
      else {
        return false;
      }
    }
  }

  public boolean accept(File dir, String name) {
    File f = new File(dir, name);
    if (f.isFile() == false)
      return false;

    int i = name.indexOf('.');
    if (i == -1)
      return false;   // nedotazene, soubor nemusi mit priponu

    String jm = new String(name.substring(0, i));
    String pr = new String(name.substring(i + 1));

    if (vyhovuje(jm, jmeno, hvezdaJmeno)
        &&  vyhovuje(pr, pripona, hvezdaPripona)) {
      return true;
    }
    else {
      return false;
    }
  }
}


public class SouboryVAdresariRek {
  static int pocetVsechAdr = 0;
  static int pocetVsechSoub = 0;
  static String maska;

  static void vypisSouboruVAdresari(String aktualniAdr) {
    String[] jmenaSoub;

    FiltrMasky filtrMas = new FiltrMasky(maska);
    File aktDir = new File(aktualniAdr);

    jmenaSoub = aktDir.list(filtrMas);
    pocetVsechSoub += jmenaSoub.length;

    // mezery, aby se stale nevypisoval adresar
    StringBuffer b = new StringBuffer(aktualniAdr.length());
    for (int i = 0;  i < aktualniAdr.length();  i++)
      b.append(' ');

    System.out.println(aktualniAdr + "\\");
    for (int i = 0;  i < jmenaSoub.length;  i++)
      System.out.println(b + "\\" + jmenaSoub[i]);
  }

  static void rekVypis(String aktualniAdr) {
    String[] jmenaAdr;

    // nejdrive vypis souboru
    vypisSouboruVAdresari(aktualniAdr);

    // pak rekurentni pruchod adresari
    File aktDir = new File(aktualniAdr);
    FiltrAdresaru filtrAdr = new FiltrAdresaru();

    jmenaAdr = aktDir.list(filtrAdr);
    pocetVsechAdr += jmenaAdr.length;
    for (int i = 0;  i < jmenaAdr.length;  i++) {
      String podadr = new String (aktualniAdr + "\\" + jmenaAdr[i]);
      // rekurzivni pruchod
      rekVypis(podadr);
    }
  }


  public static void main(String[] args) throws IOException{
    Scanner sc = new Scanner(System.in);
    String jmenoAktDir;

    if (args.length == 0) {
      jmenoAktDir = System.getProperty("user.dir");
      maska = "*.*";
    }
    else {
      jmenoAktDir = new String(args[0]);
      System.out.print("Zadej masku souboru (napr. a*.ja* ): ");
      maska = sc.nextLine();
    }

    rekVypis(jmenoAktDir);
    System.out.println("Celkovy pocet vsech souboru:  " + pocetVsechSoub);
    System.out.println("Celkovy pocet vsech adresaru: " + pocetVsechAdr);
  }
}
