import java.io.*;
import java.util.*;

public class BinarniSoubor {
  final static int N = 10;
  int[][] pole;

  BinarniSoubor() {
    pole = new int[N][];
    for (int i = 0;  i < N;  i++) {
      pole[i] = new int[N];
    }
  }

  public void cteniSouboru() throws IOException {
    BufferedReader in = new BufferedReader(
                        new FileReader("pole.txt"));
    String radka;
    int i = 0;
    int j = 0;;

    while((radka = in.readLine()) != null) {
      String[] cisla = radka.split("\\p{Punct}");
      for (String cislo : cisla) {
        int k = Integer.parseInt(cislo.trim());
        pole[i][j] = k;
        j++;
      }
      j = 0;
      i++;
    }

    in.close();
  }

  public void vypisPole() {
    for (int i = 0;  i < N;  i++) {
      for (int j = 0;  j < N;  j++) {
        System.out.print(pole[i][j] + "  ");
      }
      System.out.println();
    }
  }

  public void zapisDoBinarnihoSouboru() throws IOException {
    DataOutputStream fw = new DataOutputStream(
                          new FileOutputStream("poleint.bin"));

    for (int i = 0;  i < N;  i++) {
      for (int j = 0;  j < N;  j++) {
        fw.writeInt(pole[i][j]);
      }
    }
    fw.close();
  }

  public static void main(String[] args) throws IOException {
    BinarniSoubor b = new BinarniSoubor();
    b.cteniSouboru();
    b.vypisPole();
    b.zapisDoBinarnihoSouboru();
  }
}